unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Gauges, Menus,
  VBScript_RegExp_55_TLB;

//-----------------------------------------------------------------------------
type
    TPageInfo = record
        URL: string;
        HttpCode: integer;
        ContentsType: string;
        Title: string;
        Description: string;
    end;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuExit: TMenuItem;
    MenuMisc: TMenuItem;
    MenuInfo: TMenuItem;
    MenuStayOnTop: TMenuItem;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Splitter1: TSplitter;
    Memo2: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure MenuInfoClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuStayOnTopClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    FRegBuf: TRegExp;
    FStrBuf: TStringList;
    function GetPageInformation(const URL: string): TPageInfo;
  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    Jconvert, Info, Http;

//-----------------------------------------------------------------------------
//  2005.09.03  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
    FRegBuf := TRegExp.Create(nil);
    FStrBuf := TStringList.Create();
end;

//-----------------------------------------------------------------------------
//  2005.09.03  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    FRegBuf.Free;
    FStrBuf.Free;
end;

//-----------------------------------------------------------------------------
//  2005.09.03  Pagȅ擾
function TMainForm.GetPageInformation(const URL: string): TPageInfo;

    //  Tu}b`1ڂ߂
    function GetSubMatchItem0(const Data, Pattern: string): string;
    var
        Matches, SubMatches: OleVariant;
    begin
        Result := '';
        FRegBuf.Pattern := Pattern;
        FRegBuf.Global := false;            //  ŏ
        FRegBuf.IgnoreCase := true;         //  啶E
        Matches := FRegBuf.Execute(Data);   //  
        if (Matches.Count > 0) then
        begin
            SubMatches := Matches.Item[0].SubMatches;
            if (SubMatches.Count > 0) then
            begin
                Result := SubMatches.Item[0];
            end;
        end;
    end;

var
    ss: TStringStream;
    Data, Pattern: string;
begin
    //  
    FillChar(Result, SizeOf(Result), #0);

    //  URLZbg
    Result.URL := URL;

    ss := nil;
    try
        //  f[^󂯎Xg[쐬
        ss := TStringStream.Create('');

        //  _E[h
        Result.HttpCode := GetHttpData(URL, ss);

        //  gǂݎ
        if (Result.HttpCode = 200) then
        begin
            Data := ss.DataString;
            FreeAndNil(ss);

            //  s𗎂Ƃ
            Data := StringReplace(Data, #13, '', [rfReplaceAll]);
            Data := StringReplace(Data, #10, '', [rfReplaceAll]);

            //  ^Cg^O̔
            Pattern := '<TITLE>([^<]*)</TITLE>';
            Result.Title := GetSubMatchItem0(Data, Pattern);

            //  ̔
            Pattern := '<META[\s]*NAME[\s]*=[\s]*"?[\s]*description[\s]*"?[\s]*CONTENT[\s]*=[\s]*"?[^>"]*"?[\s]*>';
            Result.Description := GetSubMatchItem0(Data, Pattern);
        end
        else
        begin
            ShowMessage(ss.DataString);
        end;
    finally
        //  Xg[j
        FreeAndNil(ss);
    end;
end;

(*
//  ---------------------------------------------------------------------------
//  HREF쐬
function    BuildHref(const URL, Title: string): string;
const
    FMT = '<a target="link" href="%s">%s</a>';
var
    T: string;
begin
    //  ^CgȂ΁AURLőp
    if (Title = '') then T := URL else T := Title;
    //  
    Result := Format(FMT, [URL, T]);
end;

//  ---------------------------------------------------------------------------
//  ܂t
function    DecorateTag(const S: string): string;
var
    S1: string;
begin
    S1 := FormatDateTime(':[yyyy/mm/dd]', Now);
    Result := Format('%s%s%s', ['<li>', S, S1]);
end;
*)

//  ---------------------------------------------------------------------------
//  s
procedure TMainForm.MenuInfoClick(Sender: TObject);
begin
    OpenInfoForm();
end;

procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

procedure TMainForm.MenuStayOnTopClick(Sender: TObject);
begin
    if (MenuStayOnTop.Checked) then
        Self.FormStyle := fsStayOnTop
    else
        Self.FormStyle := fsNormal;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
var
    PageInfo: TPageInfo;
begin
    if (Memo1.Lines.Count > 0) then
    begin
        PageInfo := GetPageInformation(Memo1.Lines.Strings[0]);
        ShowMessage(PageInfo.Title);
        ShowMessage(PageInfo.Description);
    end;
end;

end.

